diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/helper/wifi-co-trace-helper.cc ns-3.44/src/wifi/helper/wifi-co-trace-helper.cc
--- ns-3.43/src/wifi/helper/wifi-co-trace-helper.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/wifi/helper/wifi-co-trace-helper.cc	2025-03-09 16:55:49.779372700 -0700
@@ -0,0 +1,387 @@
+/*
+ * Copyright (c) 2024 Indraprastha Institute of Information Technology Delhi
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ */
+
+#include "wifi-co-trace-helper.h"
+
+#include "ns3/assert.h"
+#include "ns3/log.h"
+#include "ns3/names.h"
+#include "ns3/net-device-container.h"
+#include "ns3/node-container.h"
+#include "ns3/node-list.h"
+#include "ns3/node.h"
+#include "ns3/pointer.h"
+#include "ns3/wifi-mac.h"
+#include "ns3/wifi-net-device.h"
+#include "ns3/wifi-phy-state-helper.h"
+#include "ns3/wifi-phy.h"
+
+#include <iomanip>
+#include <iostream>
+#include <sstream>
+#include <string>
+
+namespace ns3
+{
+
+NS_LOG_COMPONENT_DEFINE("WifiCoTraceHelper");
+
+WifiCoTraceHelper::WifiCoTraceHelper()
+{
+    NS_LOG_FUNCTION(this);
+}
+
+WifiCoTraceHelper::WifiCoTraceHelper(Time startTime, Time stopTime)
+{
+    NS_LOG_FUNCTION(this << startTime.As(Time::S) << stopTime.As(Time::S));
+    NS_ASSERT_MSG(startTime <= stopTime,
+                  "Invalid Start: " << startTime << " and Stop: " << stopTime << " Time");
+
+    m_startTime = startTime;
+    m_stopTime = stopTime;
+}
+
+void
+WifiCoTraceHelper::Start(Time start)
+{
+    NS_LOG_FUNCTION(this << start.As(Time::S));
+    NS_ASSERT_MSG(start <= m_stopTime,
+                  "Invalid Start: " << start << " and Stop: " << m_stopTime << " Time");
+    NS_ASSERT_MSG(start >= Simulator::Now(),
+                  "Invalid Start: " << start << " less than Now(): " << Simulator::Now());
+    m_startTime = start;
+}
+
+void
+WifiCoTraceHelper::Stop(Time stop)
+{
+    NS_LOG_FUNCTION(this << stop.As(Time::S));
+    NS_ASSERT_MSG(m_startTime <= stop,
+                  "Invalid Start: " << m_startTime << " and Stop: " << stop << " Time");
+    NS_ASSERT_MSG(stop >= Simulator::Now(),
+                  "Invalid Stop: " << stop << " less than Now(): " << Simulator::Now());
+
+    m_stopTime = stop;
+}
+
+void
+WifiCoTraceHelper::Reset()
+{
+    NS_LOG_FUNCTION(this);
+
+    for (auto& record : m_deviceRecords)
+    {
+        record.m_linkStateDurations.clear();
+    }
+}
+
+void
+WifiCoTraceHelper::Enable(NodeContainer nodes)
+{
+    NS_LOG_FUNCTION(this << nodes.GetN());
+    NetDeviceContainer netDevices;
+    for (uint32_t i = 0; i < nodes.GetN(); ++i)
+    {
+        for (uint32_t j = 0; j < nodes.Get(i)->GetNDevices(); ++j)
+        {
+            netDevices.Add(nodes.Get(i)->GetDevice(j));
+        }
+    }
+    Enable(netDevices);
+}
+
+void
+WifiCoTraceHelper::Enable(NetDeviceContainer devices)
+{
+    NS_LOG_FUNCTION(this << devices.GetN());
+
+    for (uint32_t j = 0; j < devices.GetN(); ++j)
+    {
+        auto device = DynamicCast<WifiNetDevice>(devices.Get(j));
+        if (!device)
+        {
+            NS_LOG_INFO("Ignoring deviceId: " << devices.Get(j)->GetIfIndex() << " on nodeId: "
+                                              << devices.Get(j)->GetNode()->GetId()
+                                              << " because it is not of type WifiNetDevice");
+            continue;
+        }
+        const auto idx = m_numDevices++;
+        m_deviceRecords.emplace_back(device);
+
+        for (uint32_t k = 0; k < device->GetNPhys(); ++k)
+        {
+            auto wifiPhyStateHelper = device->GetPhy(k)->GetState();
+            auto linkCallback =
+                MakeCallback(&WifiCoTraceHelper::NotifyWifiPhyState, this).Bind(idx, k);
+            wifiPhyStateHelper->TraceConnectWithoutContext("State", linkCallback);
+        }
+    }
+}
+
+void
+WifiCoTraceHelper::PrintStatistics(std::ostream& os, Time::Unit unit) const
+{
+    NS_LOG_FUNCTION(this);
+    NS_ASSERT_MSG(m_deviceRecords.size() == m_numDevices, "m_deviceRecords size mismatch");
+
+    for (size_t i = 0; i < m_numDevices; ++i)
+    {
+        auto nodeName = m_deviceRecords[i].m_nodeName;
+        auto deviceName = m_deviceRecords[i].m_deviceName;
+        if (nodeName.empty())
+        {
+            nodeName = std::to_string(m_deviceRecords[i].m_nodeId);
+        }
+        if (deviceName.empty())
+        {
+            deviceName = std::to_string(m_deviceRecords[i].m_ifIndex);
+        }
+        auto numLinks = m_deviceRecords[i].m_linkStateDurations.size();
+        if (numLinks == 1)
+        {
+            auto& statistics = m_deviceRecords[i].m_linkStateDurations.begin()->second;
+            os << "\n"
+               << "---- COT for " << nodeName << ":" << deviceName << " ----"
+               << "\n";
+            PrintLinkStates(os, statistics, unit);
+        }
+        else if (numLinks > 1)
+        {
+            os << "\nDevice \"" << nodeName << ":" << deviceName
+               << "\" has statistics for multiple links: "
+               << "\n";
+            for (auto& linkStates : m_deviceRecords[i].m_linkStateDurations)
+            {
+                os << "\n"
+                   << "---- COT for " << nodeName << ":" << deviceName << "#Link"
+                   << std::to_string(linkStates.first) << " ---"
+                   << "\n";
+                PrintLinkStates(os, linkStates.second, unit);
+            }
+        }
+        else
+        {
+            os << "\nDevice \"" << nodeName << ":" << deviceName << "\" has no statistics."
+               << "\n";
+        }
+    }
+    os << "\n";
+}
+
+std::ostream&
+WifiCoTraceHelper::PrintLinkStates(std::ostream& os,
+                                   const std::map<WifiPhyState, Time>& linkStates,
+                                   Time::Unit unit) const
+{
+    NS_LOG_FUNCTION(this);
+    os << "Showing duration by states: "
+       << "\n";
+
+    const auto percents = ComputePercentage(linkStates);
+    const auto showPercents = !percents.empty();
+
+    std::vector<std::string> stateColumn{};
+    std::vector<std::string> durationColumn{};
+    std::vector<std::string> percentColumn{};
+
+    for (const auto& it : linkStates)
+    {
+        std::stringstream stateStream;
+        stateStream << it.first << ": ";
+        stateColumn.emplace_back(stateStream.str());
+
+        std::stringstream durationStream;
+        durationStream << std::showpoint << std::fixed << std::setprecision(2)
+                       << it.second.As(unit);
+        durationColumn.emplace_back(durationStream.str());
+
+        if (showPercents)
+        {
+            std::stringstream percentStream;
+            percentStream << std::showpoint << std::fixed << std::setprecision(2) << " ("
+                          << percents.at(it.first) << "%)";
+            percentColumn.emplace_back(percentStream.str());
+        }
+    }
+
+    AlignDecimal(durationColumn);
+    if (showPercents)
+    {
+        AlignDecimal(percentColumn);
+    }
+    AlignWidth(stateColumn);
+    AlignWidth(durationColumn);
+
+    for (size_t i = 0; i < stateColumn.size(); ++i)
+    {
+        os << stateColumn.at(i) << durationColumn.at(i);
+        if (showPercents)
+        {
+            os << percentColumn.at(i);
+        }
+        os << "\n";
+    }
+
+    return os;
+}
+
+void
+WifiCoTraceHelper::AlignDecimal(std::vector<std::string>& column) const
+{
+    size_t maxPos = 0;
+    char decimal = '.';
+
+    for (auto& s : column)
+    {
+        size_t pos = s.find_first_of(decimal);
+        if (pos > maxPos)
+        {
+            maxPos = pos;
+        }
+    }
+
+    for (auto& s : column)
+    {
+        auto padding = std::string(maxPos - s.find_first_of(decimal), ' ');
+        s = padding + s;
+    }
+}
+
+void
+WifiCoTraceHelper::AlignWidth(std::vector<std::string>& column) const
+{
+    size_t maxWidth = 0;
+
+    for (auto& s : column)
+    {
+        size_t width = s.length();
+        if (width > maxWidth)
+        {
+            maxWidth = width;
+        }
+    }
+
+    for (auto& s : column)
+    {
+        auto padding = std::string(maxWidth - s.length(), ' ');
+        s = s + padding;
+    }
+}
+
+std::map<WifiPhyState, double>
+WifiCoTraceHelper::ComputePercentage(const std::map<WifiPhyState, Time>& linkStates) const
+{
+    NS_LOG_FUNCTION(this);
+    Time total;
+    for (const auto& it : linkStates)
+    {
+        total += it.second;
+    }
+
+    if (total.IsZero())
+    {
+        return {};
+    }
+
+    std::map<WifiPhyState, double> percents;
+    for (const auto& it : linkStates)
+    {
+        percents[it.first] = it.second.GetDouble() * 100.0 / total.GetDouble();
+    }
+
+    return percents;
+}
+
+const std::vector<WifiCoTraceHelper::DeviceRecord>&
+WifiCoTraceHelper::GetDeviceRecords() const
+{
+    return m_deviceRecords;
+}
+
+void
+WifiCoTraceHelper::NotifyWifiPhyState(std::size_t idx,
+                                      std::size_t phyId,
+                                      Time start,
+                                      Time duration,
+                                      WifiPhyState state)
+{
+    NS_LOG_FUNCTION(this << idx << phyId << start.As(Time::S) << duration.As(Time::US) << state);
+    NS_ASSERT_MSG(duration.IsPositive(), "Duration shouldn't be negative: " << duration.As());
+    NS_ASSERT_MSG(idx < m_deviceRecords.size(), "Index out-of-bounds");
+
+    // Compute duration that overlaps with [m_startTime, m_stopTime]
+    const auto overlappingDuration =
+        ComputeOverlappingDuration(m_startTime, m_stopTime, start, start + duration);
+
+    if (!overlappingDuration.IsZero())
+    {
+        const auto nodeId = m_deviceRecords[idx].m_nodeId;
+        const auto deviceId = m_deviceRecords[idx].m_ifIndex;
+        const auto device = NodeList::GetNode(nodeId)->GetDevice(deviceId);
+        const auto wifiDevice = DynamicCast<WifiNetDevice>(device);
+        NS_ASSERT_MSG(wifiDevice, "Error, Device type is not WifiNetDevice.");
+
+        auto linkId = wifiDevice->GetMac()->GetLinkForPhy(phyId);
+
+        if (linkId.has_value())
+        {
+            NS_LOG_INFO("Add device node "
+                        << m_deviceRecords[idx].m_nodeId << " index "
+                        << m_deviceRecords[idx].m_ifIndex << " linkId " << *linkId << " duration "
+                        << overlappingDuration.As(Time::US) << " state " << state);
+            m_deviceRecords[idx].AddLinkMeasurement(*linkId, start, overlappingDuration, state);
+        }
+        else
+        {
+            NS_LOG_DEBUG("LinkId not found for phyId:" << phyId);
+        }
+    }
+}
+
+Time
+WifiCoTraceHelper::ComputeOverlappingDuration(Time start1, Time stop1, Time start2, Time stop2)
+{
+    const auto Zero{Seconds(0)};
+
+    NS_ASSERT_MSG(start1 >= Zero && stop1 >= Zero && start1 <= stop1,
+                  "Interval: [" << start1 << "," << stop1 << "] is invalid.");
+    NS_ASSERT_MSG(start2 >= Zero && stop2 >= Zero && start2 <= stop2,
+                  "Interval: [" << start2 << "," << stop2 << "] is invalid.");
+
+    const auto maxStart = Max(start1, start2);
+    const auto minStop = Min(stop1, stop2);
+    const auto duration = minStop - maxStart;
+
+    return duration > Zero ? duration : Zero;
+}
+
+WifiCoTraceHelper::DeviceRecord::DeviceRecord(Ptr<WifiNetDevice> device)
+    : m_nodeId(device->GetNode()->GetId()),
+      m_ifIndex(device->GetIfIndex())
+{
+    NS_LOG_FUNCTION(this << device);
+    if (!Names::FindName(device->GetNode()).empty())
+    {
+        m_nodeName = Names::FindName(device->GetNode());
+    }
+    if (!Names::FindName(device).empty())
+    {
+        m_deviceName = Names::FindName(device);
+    }
+}
+
+void
+WifiCoTraceHelper::DeviceRecord::AddLinkMeasurement(size_t linkId,
+                                                    Time start,
+                                                    Time duration,
+                                                    WifiPhyState state)
+{
+    NS_LOG_FUNCTION(this << linkId << start.As(Time::S) << duration.As(Time::S) << state);
+    auto& stateDurations = m_linkStateDurations[linkId];
+    stateDurations[state] += duration;
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/helper/wifi-co-trace-helper.h ns-3.44/src/wifi/helper/wifi-co-trace-helper.h
--- ns-3.43/src/wifi/helper/wifi-co-trace-helper.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/wifi/helper/wifi-co-trace-helper.h	2025-03-09 16:55:49.779372700 -0700
@@ -0,0 +1,217 @@
+/*
+ * Copyright (c) 2024 Indraprastha Institute of Information Technology Delhi
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ */
+
+#ifndef WIFI_CO_HELPER_H
+#define WIFI_CO_HELPER_H
+
+#include "ns3/callback.h"
+#include "ns3/config.h"
+#include "ns3/nstime.h"
+#include "ns3/ptr.h"
+#include "ns3/simulator.h"
+#include "ns3/wifi-phy-state.h"
+
+#include <iostream>
+#include <map>
+#include <string>
+#include <vector>
+
+namespace ns3
+{
+
+class WifiNetDevice;
+class NodeContainer;
+class NetDeviceContainer;
+
+/**
+ * @class WifiCoTraceHelper
+ * @brief Track channel occupancy durations for WifiNetDevice
+ *
+ * The WifiCoTraceHelper class tracks the duration that a particular WifiNetDevice is in
+ * different states.  The states are defined by the ns-3 WifiPhyStateHelper and include states such
+ * as IDLE, CCA_BUSY, TX, and RX.  The helper tracks these durations between a user-configured start
+ * and end time.  At the end of a simulation, this helper can print out statistics on channel
+ * occupancy, and permits the export of an internal data structure to allow for custom printing or
+ * statistics handling.
+ *
+ * This helper supports both single-link devices and multi-link devices (MLD).
+ */
+class WifiCoTraceHelper
+{
+  public:
+    /**
+     * @struct DeviceRecord
+     * @brief Keeps track of channel occupancy statistics observed at a WifiNetDevice.
+     *
+     * Data structure to track durations of each WifiPhy state. Elements in m_linkStateDurations are
+     * indexed by "linkId".
+     */
+    struct DeviceRecord
+    {
+        uint32_t m_nodeId;        ///< Id of Node on which the WifiNetDevice is installed.
+        std::string m_nodeName;   ///< Name of Node on which the WifiNetDevice is installed. It's
+                                  ///< empty if the name isn't configured.
+        uint32_t m_ifIndex;       ///< Device Id of WifiNetDevice.
+        std::string m_deviceName; ///< Device name. It's empty if the name isn't configured.
+
+        /**
+         * Duration statistics by link and state. LinkId is the key in the
+         * first map, and the WifiPhyState is the key to the second.
+         */
+        std::map<uint8_t, std::map<WifiPhyState, Time>> m_linkStateDurations;
+
+        /**
+         * Constructor.
+         *
+         * @param device The WifiNetDevice whose links will be monitored to collect statistics.
+         */
+        DeviceRecord(Ptr<WifiNetDevice> device);
+
+        /**
+         * Update the duration statistics for the provided linkId and state
+         *
+         * @param linkId Id of Link whose statistics is updated.
+         * @param start Time at which link switched its WifiPhyState to state.
+         * @param duration Duration of time that the link stayed in this state.
+         * @param state The state of the link from start to (start + duration).
+         */
+        void AddLinkMeasurement(size_t linkId, Time start, Time duration, WifiPhyState state);
+    };
+
+    /**
+     * Default Constructor. StartTime is Seconds(0) and stopTime is Time::Max()
+     */
+    WifiCoTraceHelper();
+
+    /**
+     * Construct a helper object measuring between two simulation time points [startTime, stopTime]
+     *
+     * @param startTime The measurement start time
+     * @param stopTime The measurement stop time
+     */
+    WifiCoTraceHelper(Time startTime, Time stopTime);
+
+    /**
+     * Enables trace collection for all nodes and WifiNetDevices in the specified NodeContainer.
+     * @param nodes The NodeContainer containing WifiNetDevices to which traces are to be connected.
+     */
+    void Enable(NodeContainer nodes);
+    /**
+     * Enables trace collection for all nodes corresponding to the devices in the specified
+     * NetDeviceContainer.
+     * @param devices The NetDeviceContainer to which traces are to be connected.
+     */
+    void Enable(NetDeviceContainer devices);
+
+    /**
+     * Starts the collection of statistics from a specified start time.
+     * @param startTime The time to start collecting statistics.
+     */
+    void Start(Time startTime);
+
+    /**
+     * Stops the collection of statistics at a specified time.
+     * @param stopTime The time to stop collecting statistics.
+     */
+    void Stop(Time stopTime);
+
+    /**
+     * Resets the current statistics, clearing all links and their durations. It does not disconnect
+     * traced callbacks. It does not clear DeviceRecords. Only the statistics collected prior to
+     * invoking this method is cleared.
+     */
+    void Reset();
+
+    /**
+     * Print measurement results on an output stream
+     *
+     * @param os The output stream to print to
+     * @param unit The unit of time in which the durations should be printed. Defaults to AUTO.
+     */
+    void PrintStatistics(std::ostream& os, Time::Unit unit = Time::Unit::AUTO) const;
+
+    /**
+     * Returns measurement results on each installed device.
+     *
+     * @return Statistics of each device traced by this helper.
+     */
+    const std::vector<DeviceRecord>& GetDeviceRecords() const;
+
+  private:
+    uint32_t m_numDevices{0};     ///< Count the number of devices traced by this helper.
+    Time m_startTime;             ///< Instant at which statistics collection should start.
+    Time m_stopTime{Time::Max()}; ///< Instant at which statistics collection should stop.
+
+    std::vector<DeviceRecord> m_deviceRecords; ///< Stores the collected statistics.
+
+    /**
+     * A callback used to update statistics.
+     *
+     * @param idx Index of the device in m_deviceRecords vector.
+     * @param phyId Id of Phy whose state is switched.
+     * @param start Instant at which link switched its WifiPhyState to state.
+     * @param duration Duration of time the link stays in this state.
+     * @param state The state of the link from start to (start + duration).
+     */
+    void NotifyWifiPhyState(std::size_t idx,
+                            std::size_t phyId,
+                            Time start,
+                            Time duration,
+                            WifiPhyState state);
+
+    /**
+     * Compute overlapping time-duration between two intervals. It is a helper function used by
+     * NotifyWifiPhyState function.
+     *
+     * @param start1 Beginning of first interval
+     * @param stop1 End of first interval
+     * @param start2 Beginning of second interval
+     * @param stop2 End of second interval
+     * @return Return the time duration common between the two intervals.
+     */
+    Time ComputeOverlappingDuration(Time start1, Time stop1, Time start2, Time stop2);
+    /**
+     * A helper function used by PrintStatistics method. It converts absolute statistics to
+     * percentages.
+     *
+     * @param linkStates Statistics of a link.
+     * @return Statistics in percentages.
+     */
+    std::map<WifiPhyState, double> ComputePercentage(
+        const std::map<WifiPhyState, Time>& linkStates) const;
+
+    /**
+     * A helper function used by PrintStatistics method. It prints statistics of a link.
+     *
+     * @param os The output stream to print to
+     * @param linkStates Statistics of a link.
+     * @param unit The unit of time in which the durations should be printed.
+     * @return The output stream after IO operations.
+     */
+    std::ostream& PrintLinkStates(std::ostream& os,
+                                  const std::map<WifiPhyState, Time>& linkStates,
+                                  Time::Unit unit) const;
+
+    /**
+     * A helper function used by PrintLinkStates method to format the output. It pads each string at
+     * left with space characters such that the decimal points are at the same position.
+     *
+     * @param column A column of strings. Each string must contain a decimal point.
+     */
+    void AlignDecimal(std::vector<std::string>& column) const;
+
+    /**
+     * A helper function used by PrintLinkStates method to format the output. It pads each string at
+     * right with space characters such that all strings have same width.
+     *
+     * @param column A column of strings.
+     */
+    void AlignWidth(std::vector<std::string>& column) const;
+};
+
+} // namespace ns3
+
+#endif
